unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,directshow,activex,comobj, StdCtrls, Renderer, ExtCtrls,
  ActnList, Buttons;

type
  TForm1 = class(TForm)
    SimpleVideo1: TSimpleVideo;
    Timer1: TTimer;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Panel2: TPanel;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure VideoRender1GetData(sender: TObject; sample: IMediaSample);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure VideoRender1Ready(sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure acStandaloneExecute(Sender: TObject);
  private
    { Private declarations }
    video : TSimpleVideo;
    FTime : int64;
  public
    { Public declarations }

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
    clrByte : Byte=0;
procedure TForm1.FormCreate(Sender: TObject);
begin
    video := SimpleVideo1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    video.Active := true;
    FTime := 0;
end;

procedure TForm1.VideoRender1GetData(sender: TObject;
  sample: IMediaSample);
var
    pData : PBYTE;
    lsize : DWORD;
    td : TREFERENCE_TIME;
begin
    sample.GetPointer( pData );
    lsize := sample.GetSize();
    FillChar( pData^, lsize, clrByte);
    inc(clrByte);

    td := FTime + 100000;
    sample.SetTime( @FTime, @td);
    FTIme := td;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    video.Active := false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    video.Width := 176;
    video.Height := 144;

    Button1Click( sender );
end;

procedure TForm1.VideoRender1Ready(sender: TObject);
var
    vw : IVideoWindow;
begin
    video.GetWindow( vw );
    if vw = nil then
        ShowMessage( 'No IVideoWIndow interface' )
    else
    begin
        acStandaloneExecute(sender);
    end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
    vw : IVideoWindow;
begin
    video.GetWindow( vw );
    vw.put_FullScreenMode( false );
    timer1.Enabled := false;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
    vw : IVideoWindow;
begin
    video.GetWindow( vw );
    vw.put_FullScreenMode( true );
    timer1.Enabled := true;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
var
    vw : IVideoWindow;
    f : LongBool;
begin

    video.GetWindow( vw );
    if vw = nil then exit;
    vw.get_FullScreenMode( f );
    if f then exit;
    vw.put_Width( panel2.Width);
    vw.put_height( panel2.height);
end;

procedure TForm1.acStandaloneExecute(Sender: TObject);
var
    vw : IVideoWindow;
begin
    video.GetWindow( vw );
    if checkbox1.Checked then
    begin
        vw.put_Owner( 0);
        vw.put_WindowStyle( WS_CAPTION or WS_DLGFRAME or WS_VISIBLE or WS_BORDER );
        vw.put_Left( 0 );
        vw.put_top(0);
    end
    else begin
        vw.put_Owner( Handle );
        vw.put_WindowStyle( WS_CHILD or WS_VISIBLE  );
        vw.put_Left( 0 );
        vw.put_top(0);
    end;

end;

end.
